#!/bin/bash

# Пинг диапазона IP адресов


par=$1
if [ "$par" == "" ] ; then
	echo -n "IP ?:"
	read ipurl
else
	ipurl=$par
fi

mode=$2
if [ "$mode" == "" ] ; then
	echo "Укажите режим работы:"
	echo "c      - обычный Ping (по списку адресов) с выводом в консоль"
	echo "cp     - обычный Ping (по списку адресов в режиме потока) с выводом в консоль"
	echo -n "режим ?:"
	read mode
fi

par=$(echo -e $ipurl | sed "s/\./ /g")
echo "$par"
ip1=$(echo -e $par | awk '{print($1)}')
ip2=$(echo -e $par | awk '{print($2)}')
ip3=$(echo -e $par | awk '{print($3)}')
ip4=$(echo -e $par | awk '{print($4)}')
#echo "ip1=$ip1  ip2=$ip2  ip3=$ip3  ip4=$ip4"

#
ip1=$(echo -e $ip1 | sed "s/-/ /g")
ip1_1=$(echo -e $ip1 | awk '{print($1)}')
ip1_2=$(echo -e $ip1 | awk '{print($2)}')
if [ "$ip1_2" == "" ] ; then
	ip1_2=$ip1_1
fi
#echo "ip1_1=$ip1_1  ip1_2=$ip1_2"

#
ip2=$(echo -e $ip2 | sed "s/-/ /g")
ip2_1=$(echo -e $ip2 | awk '{print($1)}')
ip2_2=$(echo -e $ip2 | awk '{print($2)}')
if [ "$ip2_2" == "" ] ; then
	ip2_2=$ip2_1
fi
#echo "ip2_1=$ip2_1  ip2_2=$ip2_2"

#
ip3=$(echo -e $ip3 | sed "s/-/ /g")
ip3_1=$(echo -e $ip3 | awk '{print($1)}')
ip3_2=$(echo -e $ip3 | awk '{print($2)}')
if [ "$ip3_2" == "" ] ; then
	ip3_2=$ip3_1
fi
#echo "ip3_1=$ip3_1  ip3_2=$ip3_2"

#
ip4=$(echo -e $ip4 | sed "s/-/ /g")
ip4_1=$(echo -e $ip4 | awk '{print($1)}')
ip4_2=$(echo -e $ip4 | awk '{print($2)}')
if [ "$ip4_2" == "" ] ; then
	ip4_2=$ip4_1
fi
#echo "ip4_1=$ip4_1  ip4_2=$ip4_2"


#
function cpingone()
{
	ad="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	ping -c 1 $ad 2>&1>/dev/null
	ret=$?
	if [ ${ret} -eq 0 ] ; then
		echo "$ad"
	fi
}

function cloop()
{
	while( ((ip1_1 <= ip1_2)) ) ; do
	 while( ((ip2_1 <= ip2_2)) ) ; do
	  while( ((ip3_1 <= ip3_2)) ) ; do
	   while( ((ip4_1 <= ip4_2)) ) ; do
	    cpingone
	    ((ip4_1 = ip4_1 + 1))
	   done
	   ((ip3_1 = ip3_1 + 1))
	  done
	  ((ip2_1 = ip2_1 + 1))
	 done
	 ((ip1_1 = ip1_1 + 1))
	done
}

function cploop()
{
	while( ((ip1_1 <= ip1_2)) ) ; do
	 while( ((ip2_1 <= ip2_2)) ) ; do
	  while( ((ip3_1 <= ip3_2)) ) ; do
	   while( ((ip4_1 <= ip4_2)) ) ; do
	    cpingone &
	    ((ip4_1 = ip4_1 + 1))
	   done
	   ((ip3_1 = ip3_1 + 1))
	  done
	  ((ip2_1 = ip2_1 + 1))
	 done
	 ((ip1_1 = ip1_1 + 1))
	done
}




#
case $mode in
	"c")
		cloop
	;;
	"cp")
		cploop
	;;
	*)
	;;
esac
exit 0




